// DS1307.cpp : Defines the entry point for the console application.
//


/*
upute: (proitati nakon stiskanja tipke t)

  malo radi ack, a malo ne jer se ne poklapaju bajtovi...
  zapravo, t alje samo jedan bajt od cijelog niza kojeg bi trebao poslati...

kratki hardverski podatak:
  d0 = data	(SDA)
  d1 = clock	(SCL)
  ack= datain	(SDA)

  pokuavaj i sretno :)
*/

#include "stdafx.h"

#define PPort	888

#define SCL(x) Out32(PPort, (Inp32(PPort) & 0xFD) | ((x)?0x02:0x00))
#define impuls() SCL(true);SCL(false)

// samo za postavljanje SDA
__forceinline void SDA(bool x) {
	Out32(PPort, (Inp32(PPort) & 0xFE) | (x?0x01:0x00));
}

// samo za itanje SDA
__forceinline bool SDA() {
	return !!(Inp32(PPort + 1) & 0x40);
}

// provjeri da li je ack... zasad radi bez greke!
__forceinline bool getack() {
	bool rez;
	SDA(true); /* omogui pullup otpornik, tj.
					s obzirom da je d0 spojen sa input linijom, itao bi 0... */
	SCL(true);
	rez = !SDA();
	SCL(false);

	return rez;
}

// eka ANY key
void waitkey() {
	while (!kbhit());
	if (!getch()) getch();
}

//...
void upute () {
	puts("Help:");
	puts(" ESC - izlaz");
	puts(" H - ovaj help");
	puts(" d - data");
	puts(" c - clock");
	puts(" g - read");
	puts(" t - test"); /* moje iskustvo je pokazalo da je dobro
							imati taj t za jedan dio koji bi se non-stop mijenjao
							za razliite pokuse, tako da se ne zatrpava bezveze tablica
							komandi! */
	puts(" s - sekundara");
	puts("---------");
	putch('\n');
}

// u uputama pie da tako zapoinje komunikacija...
void starttransfer() {
	SDA(false);
	SCL(false);
}

// ..., a da tako zavrava
void stoptransfer() {
	SCL(false);
	SCL(true);
	SDA(true);
}

// zasad radi...
bool sendbyte(BYTE bjt) {
	int a;
	for (a= 0; a<8;++a) {
		SDA(!!(bjt & 0x80));
		impuls();
		bjt<<=1;
	}
	
	return getack();
}

/* pozove funkciju sendbyte na malo drugaiji nain.
   Mislim da nakon to pree jedan dio u uputama e moda vie
   preferirati ovu funkciju */
__forceinline bool sendbyte(BYTE bjt, bool read) {
	return sendbyte(bjt | (BYTE)read);
}

// nije probano, ali bi vrlo vjerojatno moglo raditi!!!!!!!
byte getbyte(bool ack) {
	BYTE data = 0;
	int a;
	for (a=0;a<8;a++) {
		SCL(true);
		data = (data<<1) | (BYTE)SDA();
		SCL(false);
	}
	SDA(ack);
	impuls();

	return data;
}


byte getsec() {
	byte x;
//	puts("----------------");
//	puts("Zapocinjem primanje...");
	starttransfer();
	sendbyte(0xD0, false);
	sendbyte(0x00);
	stoptransfer();

//	puts("Primam (od sekundi)...");
	starttransfer();
	sendbyte(0xD0, true);
	x = getbyte(true);
	stoptransfer();
//	puts("Sekunde primljene! Komunikacija zavrsena.");
	return (x & 0x0F) + (((x & 0xF0) >> 4) * 10);
}


/////////////////////////////////////////////////////////////////////////////////
int main(int argc, char* argv[]) {
	bool d;

	Out32 (PPort, 0x03);
	puts ("Sad zatekaj pa stisni ANY key!");
	waitkey();

	upute();
	for (;;) {
		switch (getch()) {
			case 'h':
			case 'H':
				upute();
				break;
			case 27:
				puts("Itekaj pa stisni ANY key!");
				waitkey();
				goto kraj;
			case 'd':
				d=!(Inp32(PPort) & 1);
				SDA(d);
				printf("SDA = %d\n", d);
				break;
			case 'c':
				d=!(Inp32(PPort) & 2);
				SCL(d);
				printf("SCL = %d\n", d);
				break;
			case 'g':
				printf("SDA = %d\n", SDA());
				break;
			case 't':
				starttransfer();
				puts("-------------------------");
				puts("Konektiranje na divajs...");
				
				if (sendbyte(0xD0, false))
					puts("Primio ack!");
				else
					puts("Nisam primio ack!!!");
				puts("Definiram slanje sekundi...");
				if (sendbyte(0x00, false))
					puts("Primio ack!");
				else
					puts("Nisam primio ack!");

				puts("Saljem '14' sekundi...");
				if (sendbyte(0x14,false))
					puts("Primio ack!");
				else
					puts("Nisam primio ack!");

				puts("Kraj prijenosa:");
				stoptransfer();
				puts("Gotovo!");
				break;
			case 's':
				printf("Sekundi: %d\n", getsec());
				break;
		}
	}
kraj:
	return 0;
}
